Require Import prelude.
Require Import ninfty.
Require Import hlemmas.

Lemma crucial : forall (A B : Type) (O : Type), omniscient O ->
                 forall (f : A + B -> O) g, section_retraction f g ->
                 A + ¬ A.
  intros.
  Print omniscient.
  destruct (X (fun o => match g o with
                         inl _ => true
                       | inr _ => false
                        end)).
  + left; destruct s as [x ?]; case_eq (g x); intros.
    - exact a.
    - rewrite H0 in e; inversion e.
  + right; intros a.
    specialize (e (f (inl a))); rewrite H in e; inversion e.
Qed.

Section PEM.

  Variable hset_CB :
    forall (A B : Type) (f : A -> B) (g : B -> A),
      hset A -> hset B -> injective f -> injective g -> Σ (r : A -> B), (Σ r_inv, inverse r r_inv).

  Variable A : Type.
  Variable Aprop : hprop A.

  Theorem PEM : A + ¬ A.
    pose (f := fun x => match (x : A + _) with
                         inr k => succ_infty k
                       | inl _ => zero_infty
                        end).
    pose (g := @inr A ℕ∞).
    assert (injective g) by (intros ? ? H; injection H; congruence).
    assert (injective f).    
    {
      intros ? ? ?.
      destruct a, a'; subst f; simpl in *.
      + apply f_equal, Aprop.
      + exfalso; eapply noconf_infty; eauto.
      + exfalso; eapply noconf_infty; eassumption.
      + apply f_equal, injective_succ_infty, H0.
    }
    assert (hset (A + ℕ∞)) by (apply plus_hset; [apply hprop_hset, Aprop | apply N_infty_hset]).
    destruct (hset_CB _ _ f g H1 N_infty_hset H0 H) as [s [r [p q]]].
    eapply crucial; eauto.
    apply N_infty_omniscient.
  Qed.

End PEM.
