Require Import prelude.
Require Import hlemmas.
Require Import ninfty.
Require Import topem.

Section trunc.

  Variable trunc : Type -> Type.
  Variable trunc_intro : forall {A : Type}, A -> trunc A.
  Variable trunc_eq : forall {A : Type} (a b : trunc A), a = b.
  Variable trunc_ind : forall {A : Type} (B : Type), hprop B -> (A -> B) -> trunc A -> B.

  Variable trunc_hset_CB : forall (A B : Type) (f : A -> B) (g : B -> A),
      hset A -> hset B -> injective f -> injective g -> trunc (Σ (r : A -> B), (Σ r_inv, inverse r r_inv)).

  Variable A : Type.
  Variable Aprop : hprop A.

  Theorem PEM : A + ¬ A.
    pose (f := fun x => match (x : _ + A) with
                         inl k => succ_infty k
                       | inr _ => zero_infty
                        end).
    pose (g := @inl ℕ∞ A).
    assert (injective g) by (intros ? ? H; injection H; congruence).
    assert (injective f).    
    {
      intros ? ? ?.
      destruct a, a'; subst f; simpl in *.
      + apply f_equal, injective_succ_infty, H0.
      + exfalso; eapply noconf_infty; eassumption.
      + exfalso; eapply noconf_infty; eauto.
      + apply f_equal, Aprop.
    }
    assert (hset (ℕ∞ + A)) by (apply plus_hset; [apply N_infty_hset|apply hprop_hset, Aprop]).
    specialize (trunc_hset_CB _ _ f g H1 N_infty_hset H0 H).
    apply (fun z t => trunc_ind _ _ z t trunc_hset_CB).
    + apply hpropEM_hprop; assumption.
    + intros [s [r [p _]]]; eapply crucial;[|eassumption].
      apply N_infty_omniscient.
  Qed.

End trunc.
